% Get some info from PicoScope
clear all;
% Suppress loadlibrary warnings; error in PicoTech .h file, can't fix
warning off MATLAB:loadlibrary:TypeNotFound;
warning off MATLAB:loadlibrary:TypeNotFoundForStructure;
if ~libisloaded('PS3000.dll')
	loadlibrary('PS3000.dll','PS3000.h');
end;
%fprintf('Library loaded.\n');
num_pico = 0;
opened = 1;
while opened
	%-1 if the oscilloscope fails to open,
	%0 if no oscilloscope is found,
	%>0 (device handle) if the device opened
	unithandle(num_pico+1)=calllib('PS3000', 'ps3000_open_unit');
	if unithandle(num_pico+1) > 0
		opened = 1;
		fprintf('Picoscope unit %d opened.\n',num_pico+1);
		num_pico = num_pico + 1;
	else
		opened = 0;
		if unithandle(num_pico+1) == -1
			fprintf('Failed to open unit %d.\n',num_pico+1);
		else % 0
			%fprintf('Unit %d not found.\n',num_pico+1);
		end;
	end;
end;

%drawnow;

for i=1:num_pico
	fprintf('Unit %d:\n',i);
	handle = unithandle(i);

	string_length = 50;
	init_val(1:string_length) = 'p';
	s = libpointer('stringPtr',init_val);
	
	code = 0; % 0 = version string, 6 = error code
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tDriver version: %s\n',str);
	str = ' ';

	code = 1; 
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tUSB version: %s\n',str);
	str = ' ';
	
	code = 2; 
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tHardware version: %s\n',str);
	str = ' ';

	code = 3; 
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tVariant info: %s\n',str);
	str = ' ';

	code = 4; 
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tBatch and serial: %s\n',str);
	str = ' ';

	code = 5; 
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tCal date: %s\n',str);
	str = ' ';

	code = 6; 
	[num,str] = calllib('PS3000','ps3000_get_unit_info',handle,s,string_length,code);
	fprintf('\tError string: %s\n',str);
	str = ' ';

end;


for i=1:num_pico
	calllib('PS3000','ps3000_close_unit',unithandle(i));
end;
unloadlibrary('PS3000');
%fprintf('PicoScope closed, DLL unloaded.\n');
